MODULE AggBSpline;

IMPORT
  bas := AggBasics;

(* --------------------------------------------------------------------bspline *)
(* A very simple class of Bi-cubic Spline interpolation.                       *)
(* First call init(num, x[], y[]) where num - number of source points,         *)
(* x, y - arrays of X and Y values respectively. Here Y must be a function     *)
(* of X. It means that all the X-coordinates must be arranged in the ascending *)
(* order.                                                                      *)
(* Then call get(x) that calculates a value Y for the respective X.            *)
(* The class supports extrapolation, i.e. you can call get(x) where x is       *)
(* outside the given with init() X-range. Extrapolation is a simple linear     *)
(* function.                                                                   *)
TYPE
  bspline_ptr* = POINTER TO bspline;
  bspline* = RECORD
    max, num: bas.int32;
    x, y, am: POINTER TO ARRAY OF bas.double;
    last_idx: bas.int32;
  END;

PROCEDURE (VAR bs: bspline) Construct*();
BEGIN
  bs.max := 0;
  bs.num := 0;

  bs.x  := NIL;
  bs.y  := NIL;
  bs.am := NIL;

  bs.last_idx := -1;
END Construct;


END AggBSpline.
