MODULE AggRenderingBuffer;

IMPORT
  bas := AggBasics,
  rts := oberonRTS;

TYPE

  rendering_buffer* = RECORD
    buf          - : bas.buffer;
    byte_width   - : bas.int32; (*    *)
    byte_height  - : bas.int32; (*    *)
    bpp          - : bas.int32; (*  -- (byte-per-pixel).   . *)
  END;

  rendering_buffer_ptr* = POINTER TO rendering_buffer;

(* bppabs *)

PROCEDURE (rc: rendering_buffer_ptr) bppabs*(): bas.int32;
BEGIN
  RETURN ABS(rc.bpp);
END bppabs;

(* row *)

PROCEDURE (rc: rendering_buffer_ptr) row*(y: bas.int32): bas.int32;
BEGIN
  IF rc.bpp <= 0 THEN
    RETURN rc.byte_height - y;
  ELSE
    RETURN y;
  END;
END row;

(* Attach *)

PROCEDURE (rc: rendering_buffer_ptr) Attach*(rbuf: rendering_buffer_ptr);
BEGIN
  rc.buf         := rbuf.buf;
  rc.byte_height := rbuf.byte_height;
  rc.byte_width  := rbuf.byte_width;
  rc.bpp         := rbuf.bpp;
END Attach;

PROCEDURE (rc: rendering_buffer_ptr) attach*(buf: bas.buffer; bytes_per_bixel: bas.int32);
BEGIN
  (*ASSERT(LEN(buf^, 1) MOD ABS(bytes_per_bixel) = 0);*)

  rc.buf         := buf;
  rc.bpp         := bytes_per_bixel;
  rc.byte_width  := LEN(buf^, 1) (*DIV ABS(bytes_per_bixel)*);
  rc.byte_height := LEN(buf^, 0);
END attach;

(* Init *)

PROCEDURE (rc: rendering_buffer_ptr) Construct*();
BEGIN
  rc.buf         := NIL;
  rc.byte_width  := 0;
  rc.byte_height := 0;
  rc.bpp         := 0;
END Construct;

(* Create *)

PROCEDURE (rc: rendering_buffer_ptr) Construct1*(pixel_height, pixel_width, bytes_per_bixel: bas.int32);
VAR
  byte_width: bas.int32;
BEGIN
  byte_width := pixel_width * ABS(bytes_per_bixel);
  NEW(rc.buf, pixel_height, byte_width);

  rc.byte_width  := byte_width;
  rc.byte_height := pixel_height;
  rc.bpp         := bytes_per_bixel;
END Construct1;


(* Destroy.
      . *)

PROCEDURE (rc: rendering_buffer_ptr) Destruct*();
BEGIN
  rc.Construct();
  rts.Collect
END Destruct;

END AggRenderingBuffer.
